USE [NimsoftSLM]
GO
/****** Object:  StoredProcedure [dbo].[SP_QOS_MERGE_BY_HOST]    Script Date: 09/08/2012 03:04:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[SP_QOS_MERGE_BY_HOST] (@src varchar(255), @dest varchar(255))
as begin
set nocount on 
DECLARE @qos varchar(255), 
	@robot varchar(255),
	@dest_source varchar(255), 
	@tableid int, 
	@tableid2 int,
	@rtable varchar(255),
	@query varchar(1024),
	@target varchar(255),
	@str nvarchar(1024),
	@t_id int;

set @t_id = NULL
-- Put short name QoS-es into temporary table (this will be deleted)

select qos, robot, source, table_id, r_table, target INTO #TempQoSTable 
  from s_qos_data where robot = @src;

-- cursor for the QoS series we'd like to keep
  
DECLARE q CURSOR FOR

select qos, robot, source, target, table_id, r_table from S_QOS_DATA 
  where robot = @dest

OPEN q

FETCH NEXT FROM q 
  INTO @qos, @robot, @dest_source, @target, @tableid, @rtable

WHILE @@FETCH_STATUS = 0
   BEGIN
      -- Compare names - fetch table_id for all QoS-es matching the source QoS
      select @tableid2 = table_id from #TempQoSTable where qos = @qos and source = LOWER(@dest_source) and target = @target
      if (@tableid2 IS NOT NULL)
        begin     
          -- Merge QoS series in the RN table
			set @str = 'Table id: ' + cast(@tableid2 as varchar) + ' merging into ' + cast(@tableid as varchar)
			RAISERROR(@str,10,1) WITH NOWAIT
			set @query = 'update ' + @rtable + ' set table_id = ' + CAST(@tableid as varchar)
			+ ' where table_id = ' + CAST(@tableid2 as varchar)
			-- print to check, replace with exec to run 
			print(@query)
			--RAISERROR(@query,10,1) with nowait

          -- Delete extra row from S_QOS_DATA
          set @str = 'select @t_id=table_id from s_qos_data where table_id = ' + CAST(@tableid2 as nvarchar(32))
          exec sp_executesql @query = @str, @params = N'@t_id INT OUTPUT', @t_id = @t_id OUTPUT
		  if @t_id is not null begin
			set @query = 'delete from S_QOS_DATA where table_id = ' + CAST(@tableid2 as varchar)
			-- print to check, replace with exec to run 
			print(@query)
			--RAISERROR(@query,10,1) with nowait
		  end              
		  set @t_id = NULL
          -- Delete extra row from temp table 
          set @query = 'delete from #TempQoSTable where table_id = ' + CAST(@tableid2 as varchar)

          -- print to check, replace with exec to run 
          print(@query)
		  --RAISERROR(@query,10,1) with nowait		  
        end
	  set @tableid2 = NULL
      FETCH NEXT FROM q 
        INTO @qos, @robot, @dest_source, @target, @tableid, @rtable
    END -- end loop

CLOSE q;
DEALLOCATE q;

DROP TABLE #TempQoSTable
END